
/* "Species" - a CoreWars evolver.  Copyright (C) 2003 'Varfar' 
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 1, or (at your option) any later
 * version. 
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details. 
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA. 
 */
 
/* this file implements a lookup for code that is interested in whether something is a branch or not */

#include "opcode_branch_lookup.hpp"

const bool
	OPCODE_IS_BRANCH[OPCODE_LAST] = {
		false, // DAT,				/* must be 0 */
		true,  // SPL,
		false, // MOV,
		true,  // DJN,
		false, // ADD,
		true,  // JMZ,
		false, // SUB,
		false, // SEQ,
		false, // SNE,
		false, // SLT,
		true,  // JMN,
		true,  // JMP,
		false, // NOP,
		false, // MUL,
		false, // MODM,
		false, // DIV,
		false, // LDP,
		false  // STP,				/* 18 */
	},
	OPCODE_IS_SKIP[OPCODE_LAST] = {
		false, // DAT,				/* must be 0 */
		false, // SPL,
		false, // MOV,
		false, // DJN,
		false, // ADD,
		false, // JMZ,
		false, // SUB,
		true,  // SEQ,
		true,  // SNE,
		true,  // SLT,
		false, // JMN,
		false, // JMP,
		false, // NOP,
		false, // MUL,
		false, // MODM,
		false, // DIV,
		false, // LDP,
		false  // STP,				/* 18 */
	},
	OPCODE_CONTINUES[OPCODE_LAST] = {
		false, // DAT,				/* must be 0 */
		true,  // SPL,
		true,  // MOV,
		true,  // DJN,
		true,  // ADD,
		true,  // JMZ,
		true,  // SUB,
		true,  // SEQ,
		true,  // SNE,
		true,  // SLT,
		true,  // JMN,
		false, // JMP,
		true,  // NOP,
		true,  // MUL,
		true,  // MODM,
		true,  // DIV,
		true,  // LDP,
		true  // STP,				/* 18 */
	},
	OPCODE_IS_BRANCH_OR_SKIP[OPCODE_LAST] = {
		false, // DAT,				/* must be 0 */
		true,  // SPL,
		false, // MOV,
		true,  // DJN,
		false, // ADD,
		true,  // JMZ,
		false, // SUB,
		true,  // SEQ,
		true,  // SNE,
		true,  // SLT,
		true,  // JMN,
		true,  // JMP,
		false, // NOP,
		false, // MUL,
		false, // MODM,
		false, // DIV,
		false, // LDP,
		false  // STP,				/* 18 */
	};

const int
	NUM_OPCODE_BRANCHES = 5,
	NUM_OPCODE_SKIPS = 3,
	NUM_OPCODE_CONTINUES = 16;
